#include <stdio.h>
#include <stdlib.h>

int main(void){

    unsigned int a = 114;/*0111 0010*/ 
    unsigned int b = 21; /*0001 0101*/
    int c = 0;

    //a. and (&)
    c = a & b;
    printf("a & b = %d (16)\n  0111 0010\n& 0001 0101\n-----------\n= 0001 0000\n\n", c);
    /*
      0111 0010
    & 0001 0101
      0001 0000
    */

    //b. or (|)
    c = a | b;
    printf("a | b = %d (119)\n  0111 0010\n| 0001 0101\n-----------\n= 0111 0111\n\n", c);
    /*
      0111 0010
    | 0001 0101
      0111 0111
    */

    //c. xor (^)
    c = a ^ b;
    printf("a ^ b = %d (103)\n  0111 0010\n^ 0001 0101\n-----------\n= 0110 0111\n\n", c);
    /*
      0111 0010
    ^ 0001 0101
      0110 0111
    */

    //d. bitwise complement (~)
    c = ~a;
    printf("~a = %d (256-141=115))\n~ 0111 0010\n-----------\n= 1000 1101\n\n", c);
    /*
     ~1000 1101
    */

    //e. shift left (<<)
    c = a<<2;
    printf("~a = %d (456)\n~ 0111 0010\n-----------\n= 0001 1100 1000\n\n", c);
    /*
      0111 0010<<2
      1100 1000
    */

    //f. shift right (>>)
    c = a>>2;
    printf("~a = %d (28)\n~ 0111 0010\n-----------\n= 0001 1100\n\n", c);
    /*
      0111 0010>>2
      0001 1100
    */
   }